﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=10.7
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	Private prevIntent As Intent
	Private frontCamera As Boolean = False
End Sub

Sub Globals
	Private nfc As NFC
	Private TagTech As TagTechnology

	Private ButtonRetour As Button
	Private CustomListView1 As CustomListView
	Private xui As XUI
	
	Dim DestRect As Rect
	Private env As RuntimePermissions
	Private camEx As CameraExClass
	Private Panel1 As Panel
	Private ButtonFlashLightOff As Button
	Private ButtonFlashLightOn As Button
End Sub

Sub Activity_WindowFocusChanged(HasFocus As Boolean)
	If HasFocus Then
		Dim jo As JavaObject = Activity
		jo.RunMethod("setSystemUiVisibility", Array As Object(5894)) '3846 - non-sticky
	End If
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("Rondier")
End Sub

Private Sub ButtonRetour_Click
	StartActivity(Main)
End Sub

Sub Activity_Resume
	'force toutes les intentions nfc à être envoyées à cette activité
	 nfc.EnableForegroundDispatch
	Dim si As Intent = Activity.GetStartingIntent
	'vérifier que l'intention est une nouvelle intention
	If si.IsInitialized = False Or si = prevIntent Then Return
	prevIntent = si
	If si.Action.EndsWith("TECH_DISCOVERED") Or si.Action.EndsWith("NDEF_DISCOVERED") Or si.Action.EndsWith("TAG_DISCOVERED") Then
		Dim techs As List = nfc.GetTechList(si)
		Log($"Techs: ${techs}"$)
		'dans ce cas, nous n'accédons qu'aux balises Ndef.
		If techs.IndexOf("android.nfc.tech.Ndef") > -1 Then
			TagTech.Initialize("TagTech", "android.nfc.tech.Ndef" , si)
			'Connectez-vous au tag
			TagTech.Connect
		Else
			ToastMessageShow("Le TAG ne possède pas la technologie Ndef.", True)
		End If
	End If
	
	InitializeCamera
End Sub

Private Sub InitializeCamera
	Starter.rp.CheckAndRequest(Starter.rp.PERMISSION_CAMERA)
	Wait For Activity_PermissionResult (Permission As String, Result As Boolean)
	If Result Then
		camEx.Initialize(Panel1, frontCamera, Me, "Camera1")
		frontCamera = camEx.Front
	Else
		ToastMessageShow("Aucune autorisation!!!", True)
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	nfc.DisableForegroundDispatch
	
	If camEx.IsInitialized Then
		camEx.Release
	End If
End Sub

Sub Camera1_Ready (Success As Boolean)
	If Success Then
		camEx.SetJpegQuality(90)
		camEx.SetContinuousAutoFocus
		camEx.CommitParameters
		camEx.StartPreview
		Log(camEx.GetPreviewSize)
	Else
		ToastMessageShow("Impossible d'ouvrir la caméra.", True)
	End If
End Sub

Sub ButtonFlashLightOn_Click
	Dim f() As Float = camEx.GetFocusDistances
	Log(f(0) & ", " & f(1) & ", " & f(2))
	Dim flashModes As List = camEx.GetSupportedFlashModes
	If flashModes.IsInitialized = False Then
		ToastMessageShow("Flash non pris en charge.", False)
		Return
	End If
	'Dim flash As String = flashModes.Get((flashModes.IndexOf(camEx.GetFlashMode) + 1) Mod flashModes.Size)
	camEx.SetFlashMode("torch")
	'Log(flash)
	ToastMessageShow("Torche allumée", False)
	camEx.CommitParameters
End Sub

Sub ButtonFlashLightOff_Click
	Dim f() As Float = camEx.GetFocusDistances
	Log(f(0) & ", " & f(1) & ", " & f(2))
	Dim flashModes As List = camEx.GetSupportedFlashModes
	If flashModes.IsInitialized = False Then
		ToastMessageShow("Flash non pris en charge.", False)
		Return
	End If
	'Dim flash As String = flashModes.Get((flashModes.IndexOf(camEx.GetFlashMode) + 1) Mod flashModes.Size)
	camEx.SetFlashMode("off")
	'Log(flash)
	ToastMessageShow("Torche éteinte", False)
	camEx.CommitParameters
End Sub

Private Sub TagTech_Connected (Success As Boolean)
	Log($"Connected: ${Success}"$)
	If Success = False Then
		ToastMessageShow("Erreur de connection au TAG", True)
		Log(LastException)
	Else
		ReadNdef
	End If
End Sub

Private Sub ReadNdef
	TagTech.RunAsync("ReadNdef", "getNdefMessage", Null, 0)
End Sub

Private Sub ReadNdef_RunAsync (Flag As Int, Success As Boolean, Result As Object)
	Log($"Reading completed. Success=${Success}, Flag=${Flag}"$)
	If Success Then
		If Result = Null Then
			ToastMessageShow("Aucun enregistrement trouvé.", False)
		Else
			Dim Message As JavaObject = Result
			Dim records() As Object = Message.RunMethod("getRecords", Null)
			For Each r As NdefRecord In records
				Dim b() As Byte = r.GetPayload
				
				DateTime.DateFormat = "dd MMM yyyy"
				DateTime.TimeFormat = "HH:mm"
				
				
				CustomListView1.AddTextItem(BytesToString(b, 0, b.Length, "utf8") & " - Pointé le " & DateTime.Date(DateTime.Now) & " à " & DateTime.Time(DateTime.Now),"b")
				'Scrool automatique de la listview
				Sleep(0)
				CustomListView1.ScrollToItem(CustomListView1.Getsize - 1)
			Next
		End If
	End If
End Sub